<template functional>
  <div id="lecture_list_wrapper">
    <div>
      <!-- 아이템 순서 변경안될 시 v-sortable 수정하기 -->
      <el-table
        :data="props.list"
        :row-style="listeners['tableColumnColor']"
        class="elTable-label"
        v-sortable="data.attrs.sortableOptions"
      >
        <div slot="empty">
          {{ parent.$t("STUDENT_MENU.NO_MADE_LEC") }}
        </div>
        <el-table-column
          prop="index"
          :label="parent.$t('LECTURE_LIST.NUMBER')"
          width="90"
          align="center"
        >
          <template slot-scope="scope">
            <!--
            <el-button icon="el-icon-arrow-up" v-if="props.type === 'TEACHER'"
              type="text" size="mini" @click="listeners['up'](scope.$index)"
            />
            -->
            {{ scope.$index + 1 }}
            <!--
            <el-button icon="el-icon-arrow-down" v-if="props.type === 'TEACHER'"
              type="text" size="mini" @click="listeners['down'](scope.$index)"
            />
            -->
          </template>
        </el-table-column>

        <el-table-column
          prop="type"
          :label="parent.$t('LECTURE_LIST.TYPE')"
          width="90"
          align="left"
        >
          <template slot-scope="scope">
            <span v-if="scope.row.type === '[유인]'">
              {{ parent.$t("LECTURE.TYPE_PRESENT") }}
            </span>
            <span v-else-if="scope.row.type === '[무인]개인'">
              {{ parent.$t("LECTURE.TYPE_INDI") }}
            </span>
            <span v-else-if="scope.row.type === '[무인]단체'">
              {{ parent.$t("LECTURE.TYPE_GROUP") }}
            </span>
          </template>
        </el-table-column>

        <template v-if="props.type === 'TEACHER'">
          <el-table-column
            prop="name"
            :label="parent.$t('LECTURE_LIST.LECTURE_NAME')"
            align="left"
          ></el-table-column>
          <el-table-column
            :label="parent.$t('TEACHER_CLASS.PERIOD')"
            width="230"
            align="left"
          >
            <template slot-scope="scope">
              <div v-if="scope.row.type !== '[유인]'">
                <div v-if="scope.row.type === '[무인]단체'">
                  {{
                    scope.row.start_time
                      ? new Date(scope.row.start_time).toLocaleDateString(
                          "en-US"
                        ) +
                        " / " +
                        new Date(scope.row.start_time).toLocaleTimeString(
                          "en-US"
                        )
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                </div>
                <div v-if="scope.row.type === '[무인]개인'">
                  {{
                    scope.row.end_time
                      ? new Date(scope.row.start_time).toLocaleDateString(
                          "en-US"
                        )
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                  ~
                  {{
                    scope.row.end_time
                      ? new Date(scope.row.end_time).toLocaleDateString("en-US")
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                </div>
              </div>
            </template>
          </el-table-column>

          <!-- <el-table-column
            :label="parent.$t('LECTURE_LIST.PARTICIPANTS')"
            width="135"
            align="center"
          >
            <template slot-scope="scope">
              {{scope.row.student_number}} / {{ scope.row.capacity }}
            </template>
          </el-table-column> -->

          <!-- TODO
          <el-table-column
            label="수강 이해도(평균)"
            width="135"
             align="left"
          >
            <template slot-scope="scope">
              몇%
            </template>
          </el-table-column>
          -->

          <el-table-column label="-" width="120" align="center">
            <template slot-scope="scope">
              <router-link
                :to="
                  `/a/teacher/NNlecture/${scope.row.lecture_id}/live?classId=${scope.row.class_id}`
                "
              >
                <el-button
                  class="LectureListTeachingButton"
                  v-if="scope.row.type !== '[무인]개인'"
                  >{{ parent.$t("LECTURE_LIST.START_LECTURE") }}</el-button
                >
              </router-link>
            </template>
          </el-table-column>

          <el-table-column
            v-if="props.connectFlag"
            label="-"
            width="180"
            align="center"
          >
            <template slot-scope="scope">
              <el-button
                class="LectureListActivaiteButton"
                @click="listeners['activaite'](scope.$index)"
                v-if="scope.row.valid"
                >{{ parent.$t("LECTURE_LIST.ACTIV_NEXT_SESSION") }}</el-button
              >
            </template>
          </el-table-column>

          <el-table-column
            v-if="!props.isPhone"
            label="-"
            width="100"
            align="center"
          >
            <template slot-scope="scope">
              <router-link
                :to="
                  `/a/teacher/NNlecture/${scope.row.lecture_id}/manage?classId=${scope.row.class_id}`
                "
              >
                <el-button class="edit-btn LectureListEditButton">{{
                  parent.$t("LECTURE_LIST.EDIT")
                }}</el-button>
              </router-link>
            </template>
          </el-table-column>

          <el-table-column label="-" width="100" align="center">
            <template slot-scope="scope">
              <el-button
                class="LectureListDeleteButton"
                type="danger"
                @click="listeners['delete'](scope.$index)"
                >{{ parent.$t("LECTURE_LIST.DELETE") }}</el-button
              >
            </template>
          </el-table-column>
        </template>

        <template v-if="props.type === 'STUDENT' || props.type === 'STUDENT2'">
          <el-table-column
            prop="name"
            :label="parent.$t('STUDENT_MENU.LECTURE')"
            align="center"
          ></el-table-column>
          <el-table-column
            :label="parent.$t('STUDENT_MENU.ACTV_DUR')"
            width="300"
            align="center"
          >
            <template slot-scope="scope">
              <div v-if="scope.row.type !== '[유인]'">
                <div v-if="scope.row.type === '[무인]단체'">
                  {{
                    scope.row.start_time
                      ? new Date(scope.row.start_time).toLocaleDateString(
                          "en-US"
                        ) +
                        " / " +
                        new Date(scope.row.start_time).toLocaleTimeString(
                          "en-US"
                        )
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                </div>
                <div v-if="scope.row.type === '[무인]개인'">
                  {{
                    scope.row.end_time
                      ? new Date(scope.row.start_time).toLocaleDateString(
                          "ko-KR"
                        )
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                  ~
                  {{
                    scope.row.end_time
                      ? new Date(scope.row.end_time).toLocaleDateString("ko-KR")
                      : parent.$t("TEACHER_CLASS.UNDECIDED")
                  }}
                </div>
              </div>
            </template>
          </el-table-column>
          <!--el-table-column
            label="수강여부"
            width="100"
            align="center"
          >
            <template slot-scope="scope">
              {{ scope.row.heard }}
            </template>
          </el-table-column-->

          <!-- <el-table-column
            :label="parent.$t('LECTURE_LIST.PARTICIPANTS')"
            width="135"
            align="center"
            v-if="props.type === 'STUDENT'"
          >
            <template slot-scope="scope">
              {{scope.row.student_number}} / {{ scope.row.capacity }}
            </template>
          </el-table-column> -->

          <el-table-column label="-" width="120" align="center">
            <template slot-scope="scope">
              <el-button @click="listeners['join'](scope.$index)">
                {{ parent.$t("STUDENT_MENU.ENTER_LECTURE") }}
              </el-button>
            </template>
          </el-table-column>

          <el-table-column
            :label="parent.$t('STUDENT_MENU.QUEST_BY_LEC')"
            width="100"
            align="center"
            v-if="props.type === 'STUDENT'"
          >
            <template slot-scope="scope">
              <!-- <router-link :to="`/a/student/NNclass/${scope.row.class_id}/quiz?lectureId=${scope.row.lecture_id}`"> -->
              <!-- </router-link> -->
              <el-button @click="listeners['homework'](scope.$index)">{{
                parent.$t("STUDENT_MENU.SUBMIT")
              }}</el-button>
            </template>
          </el-table-column>
        </template>
      </el-table>
    </div>
  </div>
</template>

<script>
// TODO : 몇명, 몇% 실제 값 대입
import isArray from "lodash.isarray";
import utils from "../../utils";

export default {
  name: "LectureList",
  async created() {
    // alert('created');
  },
  /*methods: {
    tableColumnColor({ row }) {
      return 'ing';
    },
  },*/
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        const allowedTypeList = ["TEACHER", "STUDENT", "STUDENT2"];
        if (!allowedTypeList.includes(value)) {
          // eslint-disable-next-line no-console
          console.error(`prop "type" should be one of ${allowedTypeList}`);
          return false;
        }
        return true;
      }
    },
    list: {
      type: Array,
      required: true,
      validator(value) {
        if (!isArray(value)) {
          // eslint-disable-next-line no-console
          console.error('prop "list" should be type Array');
          return false;
        }
        if (value.length === 0) {
          return true;
        }
        const firstElement = value[0];
        const allowedKeyOfClassListItem = ["id"]; // TODO: improve this list
        const firstElementKeySet = new Set(Object.keys(firstElement));
        if (firstElementKeySet.size === 0) {
          throw new Error("ClassList empty element received.");
        }
        for (let i = 0; i < allowedKeyOfClassListItem; i += 1) {
          const expectedKey = allowedKeyOfClassListItem[i];
          if (!firstElementKeySet.has(expectedKey)) {
            // eslint-disable-next-line no-console
            console.error(`prop "list" should have \`${expectedKey}\``);
            return false;
          }
        }
        return true;
      }
    },
    isPhone: {
      type: null
    },
    connectFlag: {
      type: null
    }
  }
};
</script>

<style lang="scss" scoped>
#lecture_list_wrapper {
  .el-table .notyet {
    // 아직 시작 안 한 무인강의
    background: wheat;
  }
  .elTable-label .ing {
    // 진행중인 무인강의
    background: lightskyblue;
  }
  .el-table .end {
    // 종료된 무인강의
    background: #909399;
  }
  .el-table .teacher {
    // 유인강의
    background: lightpink;
  }
  /*
  .elTable-label {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
    text-align: center;
  }
  .elTable-label th {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .elTable-label td {
    font-family: SpoqaHanSans;
    font-size: 20px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #606266;
  }
  .edit-btn {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #1989fa;
  } */
}
</style>
